jjb: Disable netronome and micrel phy drivers
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
1 #!/bin/bash
2 #
3 # Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
17
18 set -exu
19
20 # Parameters
21 platforms=${platforms:-}
22 # Derive arch from label if it isn't set
23 if [ -z "${arch:-}" ] ; then
24 # Labels may be platform specific, eg. jammy-amd64, deb12-armhf
25 regex='[[:alnum:]]+-([[:alnum:]]+)'
26 if [[ "${platforms}" =~ ${regex} ]] ; then
27 arch="${BASH_REMATCH[1]}"
28 else
29 arch="${platforms:-}"
30 fi
31 fi
32
33 cross_arch=${cross_arch:-}
34 ktag=${ktag:-}
35 kgitrepo=${kgitrepo:-}
36 mversion=${mversion:-}
37 mgitrepo=${mgitrepo:-}
38 make_args=()
39
40 DEBUG=${DEBUG:-}
41
42 ## FUNCTIONS ##
43
44 # Kernel version compare functions
45 verlte() {
46 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
47 }
48
49 verlt() {
50 # shellcheck disable=SC2015
51 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
52 }
53
54 vergte() {
55 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
56 }
57
58 vergt() {
59 # shellcheck disable=SC2015
60 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
61 }
62
63 git_clone_modules_sources() {
64 mkdir -p "$MODULES_GIT_DIR"
65
66 # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
67 # as a branch name.
68 if [ "${mversion:0:5}" = "refs/" ]; then
69 git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
70 (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
71 else
72 git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
73 fi
74 }
75
76 # Checkout a shallow kernel tree of the specified tag
77 git_clone_linux_sources() {
78 mkdir -p "$LINUX_GIT_DIR"
79 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
80 }
81
82
83 # Export the kernel sources from the git repo
84 git_export_linux_sources() {
85 cd "$LINUX_GIT_DIR"
86 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
87 }
88
89
90 # Upload the tar archive to the object store
91 upload_archive_obj() {
92 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
93 rm -f "$WORKSPACE/$obj_name"
94 }
95
96
97 extract_archive_obj() {
98 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR" -I pbzip2
99 rm -f "$WORKSPACE/$obj_name"
100 }
101
102
103 tar_archive_obj() {
104 cd "$LINUX_OBJ_DIR"
105 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
106 cd -
107 }
108
109 list_gccs() {
110 local gccs
111 gccs=()
112 IFS=: read -r -a path_array <<< "$PATH"
113 while read -r gcc ; do
114 gccs+=("$gcc")
115 done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
116 echo "${gccs[@]}"
117 }
118
119 # Find the most recent GCC version supported by the kernel sources
120 select_compiler() {
121 local selected_cc
122
123 cd "$LINUX_SRCOBJ_DIR"
124
125 kversion=$(make -s kernelversion)
126
127 set +e
128
129 for cc in $(list_gccs) ; do
130 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
131 cc_version=$(echo "${cc}" | cut -d'-' -f2)
132 if { verlt "${kversion}" "5.17"; } && { vergt "${cc_version}" "11"; } ; then
133 # Using gcc-12+ with '-Wuse-after-free' breaks the build of older
134 # kernels (in particular, objtool). Some releases on LTS
135 # branches between 4.x and 5.15 can be built with gcc-12.
136 # @see https://lore.kernel.org/lkml/20494.1643237814@turing-police/
137 # @see https://gitlab.com/linux-kernel/stable/-/commit/52a9dab6d892763b2a8334a568bd4e2c1a6fde66
138 continue
139 fi
140 selected_cc="$cc"
141 break
142 fi
143 done
144
145 set -e
146
147 # Force gcc-4.8 for kernels before 4.4
148 if { verlt "$kversion" "4.4"; }; then
149 selected_cc='gcc-4.8'
150 fi
151
152 if [ "x$selected_cc" = "x" ]; then
153 echo "Found no suitable compiler."
154 exit 1
155 fi
156
157 _KAFLAGS=()
158 _KCFLAGS=()
159 _KCPPFLAGS=()
160 _HOSTCFLAGS=()
161 if [ "$selected_cc" != "gcc-4.8" ]; then
162 # Older kernel Makefiles do not expect the compiler to default to PIE
163 _KAFLAGS+=(-fno-pie)
164 _KCFLAGS+=(
165 -fno-pie
166 -no-pie
167 -fno-stack-protector
168 )
169 _KCPPFLAGS+=(-fno-pie)
170 fi
171
172 selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
173 if { vergte "${selected_cc_version}" "10"; } && { verlt "${kversion}" "5.10"; } ; then
174 # gcc-10 changed the default from '-fcommon' to '-fno-common', which
175 # causes a linker failure. '-fcommon' can be set on the HOSTCFLAGS
176 # to avoid the issue.
177 # @see https://gitlab.com/linux-kernel/stable/-/commit/e33a814e772cdc36436c8c188d8c42d019fda639
178 _HOSTCFLAGS+=(-fcommon)
179 fi
180
181 if [ "${cross_arch:-}" == "armhf" ] ; then
182 if { verlt "${kversion}" "5.14"; } ; then
183 # Work-around for producing instructions that aren't valid for the
184 # default architectures.
185 # Eg. Error: selected processor does not support `cpsid i' in ARM mode
186 _KCFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
187 _KCPPFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
188 fi
189 fi
190
191 if { vergt "${selected_cc_version}" "8"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
192 # This was added to -Wall in gcc 9 but some kernels do not include the fixes
193 # @see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88583
194 _KCFLAGS+=(-Wno-error=packed-not-aligned)
195 fi
196
197 export KAFLAGS="${_KAFLAGS[*]}"
198 export KCFLAGS="${_KCFLAGS[*]}"
199 export KCPPFLAGS="${_KCPPFLAGS[*]}"
200 export HOSTCFLAGS="${_HOSTCFLAGS[*]}"
201 export CC="${CROSS_COMPILE:-}${selected_cc}"
202 export HOSTCC="${selected_cc}"
203
204 make_args=(
205 CC="${CC}"
206 HOSTCC="${HOSTCC}"
207 HOSTCFLAGS="${HOSTCFLAGS:-}"
208 )
209 if [ -n "${DEBUG}" ] ; then
210 make_args+=(
211 V=1
212 )
213 fi
214 cd -
215 }
216
217 patch_linux_kernel() {
218 local commit_hash
219 commit_hash="$1"
220 set +e
221 git -C "${LINUX_GIT_REF_REPO_DIR}" format-patch -n1 --stdout "${commit_hash}" | patch -p1
222 set -e
223 if [ "$?" -gt 1 ] ; then
224 echo "Serious issue patching"
225 exit 1
226 fi
227 }
228
229 build_linux_kernel() {
230 cd "$LINUX_SRCOBJ_DIR"
231
232 kversion=$(make -s kernelversion "${make_args[@]}")
233 pahole_version="$(pahole --version | tr -d 'v')"
234
235 if { verlt "${kversion}" "3.3"; } && [ "${vanilla_config}" = "imx_v6_v7_defconfig" ] ; then
236 # imx_v6_v7 didn't exist before 06965c39b4c63933fa0a1cde2237ef85477c5655
237 if { verlt "${kversion}" "3.2"; } ; then
238 vanilla_config='mx5_defconfig'
239 else
240 vanilla_config='mx51_defconfig'
241 fi
242 fi
243
244 if { verlt "${kversion}" "3.13"; } && [ "${vanilla_config}" = "pseries_le_defconfig" ] ; then
245 # pseries_le_deconfig was introduced in f53e462e907cbaed29c49c0f10f5b8f614e1bf1d
246 vanilla_config='pseries_defconfig'
247 fi
248
249 # Generate kernel configuration
250 case "$ktag" in
251 Ubuntu*)
252 if [ "${cross_arch}" = "powerpc" ]; then
253 if vergte "${kversion}" "4.10"; then
254 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
255 exit 0
256 fi
257 fi
258
259 # Disable riscv64 config generation, we don't have a toolchain on bionic
260 sed -i 's/riscv64 //' debian.master/etc/kernelconfig
261
262 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
263
264 # Hack for kernel Ubuntu-hwe-5.8
265 # The debian/control file is produced by the clean target above, so this
266 # check needs to happen afterwards.
267 if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
268 echo "10" > "debian/compat"
269 fi
270
271 # genconfigs check can fail in certain cases, eg. when a more recent
272 # compiler exposes kernel configuration flags which aren't set in the
273 # Ubuntu annotations.
274 # In any case, the configuration will be updated with any missing values
275 # later in our build script.
276 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
277 cp CONFIGS/"${ubuntu_config}" .config
278 ;;
279
280 *)
281 # Force 32bit build on i386, default is 64bit
282 if [ "$arch" = "i386" ]; then
283 export ARCH="i386"
284 fi
285
286 make "${vanilla_config}" "${make_args[@]}"
287 ;;
288 esac
289
290 if [ "${vanilla_config}" = "pseries_defconfig" ] && [ "${cross_arch}" = "ppc64el" ] ; then
291 # @see diff <(git show v3.13:arch/powerpc/configs/pseries_defconfig) <(git show v3.13:arch/powerpc/configs/pseries_le_defconfig)
292 scripts/config --enable CONFIG_CPU_LITTLE_ENDIAN
293 scripts/config --enable CONFIG_CMA
294 scripts/config --disable CONFIG_XMON_DEFAULT
295 # scripts/config --disable CONFIG_VIRTUALIZATION
296 # scripts/config --disable CONFIG_KVM_BOOK3S_64
297 scripts/config --disable CONFIG_KVM_BOOK3S_64_HV
298 fi
299
300 # oldnoconfig was renamed in 4.19
301 if vergte "$kversion" "4.19"; then
302 update_conf_target="olddefconfig"
303 else
304 update_conf_target="oldnoconfig"
305 fi
306
307 # Fix 'defined(@array)' was removed from recent perl
308 if [ -f "kernel/timeconst.pl" ]; then
309 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
310 fi
311
312 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
313 if [ "$HOSTCC" != "gcc-4.8" ]; then
314 if [ -f "arch/x86/kvm/svm.c" ]; then
315 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
316 fi
317
318 if [ -f "arch/x86/kvm/vmx.c" ]; then
319 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
320 fi
321 fi
322
323 if { verlt "${kversion}" "5.11"; } && { vergte "${kversion}" "4.10"; } ; then
324 # Binutils > 2.35 strips empty symbol tables, causing obltool to fail
325 # in certain cases when files are empty.
326 # @see https://gitlab.com/linux-kernel/stable/-/commit/1d489151e9f9d1647110277ff77282fe4d96d09b
327 #
328 # There doesn't seem to be any LD/AS/AR flags to control this behaviour,
329 # therefore patching tools/objtool/elf.c is attempted.
330 patch_linux_kernel 1d489151e9f9d1647110277ff77282fe4d96d09b
331 if { verlt "${kversion}" "4.18"; } ; then
332 patch_linux_kernel e81e0724432542af8d8c702c31e9d82f57b1ff31
333 fi
334 fi
335
336 if { vergt "${selected_cc_version}" "7"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
337 # Builds fail due to -Werror=restrict in pager.o and str_error_r.o
338 if { verlt "${kversion}" "4.16"; } ; then
339 # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
340 # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=ad343a98e74e85aa91d844310e797f96fee6983b
341 patch_linux_kernel ad343a98e74e85aa91d844310e797f96fee6983b
342 fi
343 if { verlt "${kversion}" "4.17"; } ; then
344 # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
345 # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=854e55ad289ef8888e7991f0ada85d5846f5afb9
346 patch_linux_kernel 854e55ad289ef8888e7991f0ada85d5846f5afb9
347 fi
348
349 # Duplicate decalarations of __force_order
350 # @see https://gitlab.com/linux-kernel/stable/-/commit/df6d4f9db79c1a5d6f48b59db35ccd1e9ff9adfc
351 # However, kaslr_64.c doesn't exit in 4.15, 4.16, it's named pagetable.c
352 if [ -f arch/x86/boot/compressed/pagetable.c ] ; then
353 sed -i '/^unsigned long __force_order;$/d' arch/x86/boot/compressed/pagetable.c
354 fi
355 fi
356
357 if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.18"; } ; then
358 # Some old kernels fail to build when make is too new
359 # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
360 patch_linux_kernel 9564a8cf422d7b58f6e857e3546d346fa970191e
361 # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
362 patch_linux_kernel 9feeb638cde083c737e295c0547f1b4f28e99583
363 fi
364
365 if { vergte "${kversion}" "4.12"; } && { verlt "${kversion}" "4.19"; } ; then
366 # Old kernels can fail to build while on newer host kernels with errors
367 # such as:
368 # In file included from scripts/selinux/genheaders/genheaders.c:19:
369 # ./security/selinux/include/classmap.h:249:2: error: #error New address family defined, please update secclass_map.
370 # @see https://gitlab.com/linux-kernel/stable/-/commit/dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
371 #
372 patch_linux_kernel dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
373 fi
374
375 if { vergte "${kversion}" "3.18"; } && { verlt "${kversion}" "4.4"; } ; then
376 # Compatibility with binutils >= ~ 2.31
377 patch_linux_kernel b21ebf2fb4cde1618915a97cc773e287ff49173e
378 fi
379
380 # The above patch only partially applies linux 3.17, and has been, so a
381 # rebased version is used instead.
382 if { vergte "${kversion}" "3.17"; } && { verlt "${kversion}" "3.18"; } ; then
383 cat <<'EOF' | patch -p1
384 diff --git a/arch/x86/kernel/machine_kexec_64.c b/arch/x86/kernel/machine_kexec_64.c
385 index 48598105..0652c5b6 100644
386 --- a/arch/x86/kernel/machine_kexec_64.c
387 +++ b/arch/x86/kernel/machine_kexec_64.c
388 @@ -516,6 +516,7 @@ int arch_kexec_apply_relocations_add(const Elf64_Ehdr *ehdr,
389 goto overflow;
390 break;
391 case R_X86_64_PC32:
392 + case R_X86_64_PLT32:
393 value -= (u64)address;
394 *(u32 *)location = value;
395 break;
396 diff --git a/arch/x86/kernel/module.c b/arch/x86/kernel/module.c
397 index e69f9882..7c6bc9fe 100644
398 --- a/arch/x86/kernel/module.c
399 +++ b/arch/x86/kernel/module.c
400 @@ -180,6 +180,7 @@ int apply_relocate_add(Elf64_Shdr *sechdrs,
401 goto overflow;
402 break;
403 case R_X86_64_PC32:
404 + case R_X86_64_PLT32:
405 val -= (u64)loc;
406 *(u32 *)loc = val;
407 #if 0
408 diff --git a/arch/x86/tools/relocs.c b/arch/x86/tools/relocs.c
409 index bbb1d225..8deeacbc 100644
410 --- a/arch/x86/tools/relocs.c
411 +++ b/arch/x86/tools/relocs.c
412 @@ -763,6 +763,7 @@ static int do_reloc64(struct section *sec, Elf_Rel *rel, ElfW(Sym) *sym,
413 switch (r_type) {
414 case R_X86_64_NONE:
415 case R_X86_64_PC32:
416 + case R_X86_64_PLT32:
417 /*
418 * NONE can be ignored and PC relative relocations don't
419 * need to be adjusted.
420 EOF
421 fi
422
423 if ( { vergte "${kversion}" "3.15"; } && { verlt "${kversion}" "4.4"; } ) ||
424 ( { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ); then
425 # While the original motivation of this patch is for fixing builds using
426 # clang, the same error occurs between linux >= 3.15 and < 4.4, and in
427 # 4.15, 4.16.
428 #
429 # This patch only partially applies due to changes in kernel/Makefile,
430 # so a supplementary patch is needed
431 #
432 # Without this patch, builds fail with
433 # Cannot find symbol for section 2: .text.
434 # kernel/elfcore.o: failed
435 #
436 # @see https://github.com/linuxppc/issues/issues/388
437 # @see https://lore.kernel.org/lkml/20201204165742.3815221-2-arnd@kernel.org/
438 #
439 patch_linux_kernel 6e7b64b9dd6d96537d816ea07ec26b7dedd397b9
440 if grep -q elfcore.o kernel/Makefile ; then
441 sed -i '/^.* += elfcore.o$/d' kernel/Makefile
442 fi
443 fi
444
445 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
446 # Convert them to 'cmpw' which was previously done silently
447 if verlt "$kversion" "4.9"; then
448 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
449 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
450 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
451 fi
452
453 # Fix a typo in v2.6.36.x
454 if [ -f "arch/x86/kernel/entry_64.S" ]; then
455 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
456 fi
457
458 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
459 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
460 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
461 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
462 fi
463
464 # Fix kernel < 3.0 with gcc >= 4.7
465 if verlt "$kversion" "3.0"; then
466 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
467 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
468 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
469 echo "header-y += linkage.h" >> include/linux/Kbuild
470 fi
471
472 if [ "${cross_arch}" = "powerpc" ] ; then
473 if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.16"; } ; then
474 # Avoid register errors such as
475 # aes_generic.c:(.text+0x4e0): undefined reference to `_restgpr_31_x'
476 # @see https://gitlab.com/linux-kernel/stable/-/commit/148b974deea927f5dbb6c468af2707b488bfa2de
477 make_args+=(
478 CFLAGS_aes_generic.o=''
479 )
480 fi
481 fi
482
483 if [ "$(scripts/config --state CONFIG_DEBUG_INFO_BTF)" == "y" ] &&
484 { vergte "${pahole_version}" "1.24"; } &&
485 { vergte "${kversion}" "5.10"; } && { verlt "${kversion}" "6.0"; } ;then
486 # Some kernels Eg. Ubuntu-hwe-5.13-5.13.0-52.59_20.04.1
487 # fail with the following error:
488 # BTFIDS vmlinux
489 # FAILED: load BTF from vmlinux: Invalid argument
490 #
491 # When CONFIG_DEBUG_INFO_BTF is set, certain versions of pahole require
492 # `--skip_encoding_btf_enum64` to be passed as the kernel doesn't define
493 # BTF_KIND_ENUM64.
494 #
495 # Introduced in 341dfcf8d78eaa3a2dc96dea06f0392eb2978364 (~v5.10)
496 # @see https://lore.kernel.org/bpf/20220825171620.cioobudss6ovyrkc@altlinux.org/t/
497 #
498 if [ -f "scripts/pahole-flags.sh" ] ; then
499 sed -i 's/ -J ${PAHOLE_FLAGS} / -J ${PAHOLE_FLAGS} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
500 else
501 sed -i 's/ -J ${extra_paholeopt} / -J ${extra_paholeopt} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
502 fi
503 fi
504
505 # GCC 4.8
506 if [ "$HOSTCC" == "gcc-4.8" ]; then
507 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
508 scripts/config --disable CONFIG_PPC_OF_BOOT_TRAMPOLINE
509 fi
510
511 # Don't try to sign modules
512 scripts/config --disable CONFIG_MODULE_SIG
513
514 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
515 scripts/config --disable CONFIG_STACK_VALIDATION
516
517 # Cause problems with inline assembly on i386
518 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
519
520 # Don't build samples, they are broken on some kernel releases
521 scripts/config --disable CONFIG_SAMPLES
522 scripts/config --disable CONFIG_BUILD_DOCSRC
523
524 # Disable kcov
525 scripts/config --disable CONFIG_KCOV
526
527 # Broken on some RT kernels
528 scripts/config --disable CONFIG_HYPERV
529
530 # Broken drivers
531 scripts/config --disable CONFIG_RAPIDIO_TSI721
532 scripts/config --disable CONFIG_SGI_XP
533 scripts/config --disable CONFIG_MFD_WM8994
534 scripts/config --disable CONFIG_DRM_RADEON
535 scripts/config --disable CONFIG_SND_SOC_WM5100
536 # More recent compiler optimizations (from gcc 8 onwards )expose build errors
537 # with netronome on older kernels.
538 # Observed in 4.11-rt, 4.15-4.17, 5.0-rt - 5.16-rt
539 # It seems easier to disable the driver than to attempt patching.
540 # Eg.
541 # In function ‘ur_load_imm_any’,
542 # inlined from ‘jeq_imm’ at drivers/net/ethernet/netronome/nfp/bpf/jit.c:3146:13:
543 # ./include/linux/compiler.h:350:45: error: call to ‘__compiletime_assert_1062’ declared with attribute error: FIELD_FIT: value too large for the field
544 # 350 | _compiletime_assert(condition, msg, __compiletime_assert_, __COUNTER__)
545 #
546 scripts/config --disable CONFIG_NET_VENDOR_NETRONOME
547 # Eg.
548 # In function ‘memcpy’,
549 # inlined from ‘kszphy_get_strings’ at drivers/net/phy/micrel.c:664:3:
550 # ./include/linux/string.h:305:25: error: call to ‘__read_overflow2’ declared with attribute error: detected read beyond size of object passed as 2nd parameter
551 # 305 | __read_overflow2();
552 # | ^~~~~~~~~~~~~~~~~~
553 # make[3]: *** [scripts/Makefile.build:308: drivers/net/phy/micrel.o] Error 1
554 #
555 scripts/config --disable CONFIG_MICREL_PHY
556
557
558 # IGBVF won't build with recent gcc on 2.6.38.x
559 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
560 scripts/config --disable CONFIG_IGBVF
561 fi
562
563 # Don't fail the build on warnings
564 scripts/config --disable CONFIG_WERROR
565 scripts/config --enable CONFIG_PPC_DISABLE_WERROR
566
567 # Set required options
568 scripts/config --enable CONFIG_TRACEPOINTS
569 scripts/config --enable CONFIG_KALLSYMS
570 scripts/config --enable CONFIG_HIGH_RES_TIMERS
571 scripts/config --enable CONFIG_KPROBES
572 scripts/config --enable CONFIG_FTRACE
573 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
574 scripts/config --enable CONFIG_KALLSYMS_ALL
575 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
576 scripts/config --enable CONFIG_PERF_EVENTS
577 scripts/config --enable CONFIG_EVENT_TRACING
578 scripts/config --enable CONFIG_KRETPROBES
579
580 if [ -n "${DEBUG}" ] ; then
581 cat .config
582 fi
583
584 make "$update_conf_target" "${make_args[@]}"
585 make -j"$NPROC" "${make_args[@]}"
586
587 krelease=$(make -s kernelrelease "${make_args[@]}")
588
589 # Save the kernel and modules
590 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
591 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install "${make_args[@]}"
592 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install "${make_args[@]}"
593 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
594 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
595 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
596 }
597
598
599 extract_distro_headers() {
600
601 # Enter linux source dir
602 cd "${LINUX_SRCOBJ_DIR}"
603
604
605 # For RT kernels, copy version file
606 if [ -s localversion-rt ]; then
607 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
608 fi
609
610 # Copy all Makefile related stuff
611 find . -path './include/*' -prune \
612 -o -path './scripts/*' -prune -o -type f \
613 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
614 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
615 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
616
617 # Copy base scripts and include dirs
618 cp -a scripts include "${LINUX_HDROBJ_DIR}"
619
620 # Copy arch includes
621 (find arch -name include -type d -print0 | \
622 xargs -0 -n1 -i: find : -type f) | \
623 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
624
625 # Copy arch scripts
626 (find arch -name scripts -type d -print0 | \
627 xargs -0 -n1 -i: find : -type f) | \
628 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
629
630 # Cleanup scripts
631 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
632 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
633
634 # On powerpc 32bits this object is required to link modules
635 if [ "${karch}" = "powerpc" ]; then
636 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
637 :
638 else
639 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
640 fi
641 fi
642
643 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
644 if [ "${karch}" = "arm64" ]; then
645 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
646 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
647 fi
648 fi
649
650 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
651 if [ -f tools/objtool/objtool ]; then
652 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
653 fi
654
655 if [ -f "arch/x86/kernel/macros.s" ]; then
656 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
657 fi
658
659 # Copy modules related stuff, if available
660 if [ -s Module.symvers ]; then
661 cp Module.symvers "${LINUX_HDROBJ_DIR}"
662 fi
663
664 if [ -s System.map ]; then
665 cp System.map "${LINUX_HDROBJ_DIR}"
666 fi
667
668 if [ -s Module.markers ]; then
669 cp Module.markers "${LINUX_HDROBJ_DIR}"
670 fi
671
672 # Copy config file
673 cp .config "${LINUX_HDROBJ_DIR}"
674
675 # Make sure the Makefile and version.h have a matching timestamp so that
676 # external modules can be built
677 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
678 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
679 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
680 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
681 else
682 echo "Missing version.h"
683 exit 1
684 fi
685 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
686
687 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
688 if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
689 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
690 fi
691
692 # Finally clean the object files from the full source tree
693 make clean
694
695 # And regen the modules support files
696 make modules_prepare "${make_args[@]}"
697
698 # On powerpc 32bits this object is required to link modules
699 if [ "${karch}" = "powerpc" ]; then
700 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
701 :
702 else
703 make arch/powerpc/lib/crtsavres.o "${make_args[@]}"
704 fi
705 fi
706
707 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
708 if [ "${karch}" = "arm64" ]; then
709 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
710 make arch/arm64/kernel/ftrace-mod.o "${make_args[@]}"
711 fi
712 fi
713
714 # Version specific tasks
715 case "$ktag" in
716 Ubuntu*)
717 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
718 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
719 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
720 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
721 ;;
722 esac
723 }
724
725
726 build_modules() {
727
728 local kdir="$1"
729 local outdir="$2"
730 local kversion
731
732 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
733
734 # Try to catch some compatibility problems by turning some
735 # warnings into errors.
736 #export KCFLAGS="$KCFLAGS -Wall -Werror"
737
738 # Enter lttng-modules source dir
739 cd "${MODULES_GIT_DIR}"
740
741 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
742 # timekeeping subsystem. We want those build to fail.
743 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
744 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
745
746 set +e
747
748 # Build modules
749 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
750 ret=$?
751
752 set -e
753
754 # We expect this build to fail, if it doesn't, fail the job.
755 if [ "$ret" -eq 0 ]; then
756 echo "This build should have failed."
757 exit 1
758 fi
759
760 # We have to publish at least one file or the build will fail
761 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
762
763 KERNELDIR="${kdir}" make clean
764
765 else # Regular build
766
767 # Build modules against full kernel sources
768 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
769
770 # Install modules to build dir
771 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
772
773 # Clean build dir
774 KERNELDIR="${kdir}" make clean
775 fi
776 }
777
778
779 ## MAIN ##
780
781 # Use all CPU cores
782 NPROC=$(nproc)
783
784 MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
785 LINUX_GIT_DIR="${WORKSPACE}/src/linux"
786
787 LINUX_OBJ_DIR="${WORKSPACE}/linux"
788 LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
789 LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
790 LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
791
792 MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
793 MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
794
795 LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
796
797 OBJ_STORE_URL="s3://jenkins"
798
799 cd "$WORKSPACE"
800
801 # Create build directories
802 mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
803
804 git_clone_modules_sources
805
806 # Setup cross compile env if available
807 if [ "x${cross_arch}" != "x" ]; then
808
809 case "$cross_arch" in
810 "armhf")
811 karch="arm"
812 cross_compile="arm-linux-gnueabihf-"
813 vanilla_config="imx_v6_v7_defconfig"
814 ubuntu_config="armhf-config.flavour.generic"
815 ;;
816
817 "arm64")
818 karch="arm64"
819 cross_compile="aarch64-linux-gnu-"
820 vanilla_config="defconfig"
821 ubuntu_config="arm64-config.flavour.generic"
822 ;;
823
824 "powerpc")
825 karch="powerpc"
826 cross_compile="powerpc-linux-gnu-"
827 vanilla_config="ppc44x_defconfig"
828 ubuntu_config="powerpc-config.flavour.powerpc-smp"
829 ;;
830
831 "ppc64el")
832 karch="powerpc"
833 cross_compile="powerpc64le-linux-gnu-"
834 vanilla_config="pseries_le_defconfig"
835 ubuntu_config="ppc64el-config.flavour.generic"
836 ;;
837
838 *)
839 echo "Unsupported cross arch $cross_arch"
840 exit 1
841 ;;
842 esac
843
844 # Export variables used by Kbuild for cross compilation
845 export ARCH="${karch}"
846 export CROSS_COMPILE="${cross_compile}"
847
848 # Set arch specific values if we are not cross compiling
849 elif [ "x${arch}" != "x" ]; then
850
851 case "$arch" in
852 "i386")
853 karch="x86"
854 vanilla_config="allmodconfig"
855 ubuntu_config="i386-config.flavour.generic"
856 ;;
857
858 "amd64")
859 karch="x86"
860 vanilla_config="allmodconfig"
861 ubuntu_config="amd64-config.flavour.generic"
862 ;;
863
864 "armhf")
865 karch="arm"
866 vanilla_config="allmodconfig"
867 ubuntu_config="armhf-config.flavour.generic"
868 ;;
869
870 "arm64")
871 karch="arm64"
872 vanilla_config="allmodconfig"
873 ubuntu_config="arm64-config.flavour.generic"
874 ;;
875
876 "powerpc")
877 karch="powerpc"
878 vanilla_config="allmodconfig"
879 ubuntu_config="powerpc-config.flavour.powerpc-smp"
880 ;;
881
882 "ppc64el")
883 karch="powerpc"
884 vanilla_config="allmodconfig"
885 ubuntu_config="ppc64el-config.flavour.generic"
886 ;;
887
888 *)
889 echo "Unsupported arch $arch"
890 exit 1
891 ;;
892 esac
893 else
894 echo "No arch or cross_arch specified"
895 exit 1
896 fi
897
898
899
900 # First get the kernel build from the object store, or build it, if it's
901 # not available.
902
903 echo "# Setup endpoint
904 host_base = obj.internal.efficios.com
905 host_bucket = obj.internal.efficios.com
906 bucket_location = us-east-1
907 use_https = True
908
909 # Setup access keys
910 access_key = jenkins
911 secret_key = echo123456
912
913 # Enable S3 v4 signature APIs
914 signature_v2 = False" > "$WORKSPACE/.s3cfg"
915
916 url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
917 obj_name="linux.tar.bz2"
918
919 if [ "x${cross_arch}" = "x" ]; then
920 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/$arch/native"
921 else
922 obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/${cross_arch}"
923 fi
924
925 obj_url="$obj_url_prefix/$obj_name"
926
927 set +e
928 # In s3cmd 2.3, the return code of get when an object does not exist (64)
929 # is different than in 2.2 (12). The return codes of 's3cmd info' are
930 # consistent between 2.2 and 2.3.
931 s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
932 ret=$?
933 set -e
934
935 case "$ret" in
936 "0")
937 s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
938 extract_archive_obj
939 ;;
940
941 "12")
942 echo "File not found"
943
944 # Build all the things and upload
945 # then finish the module build...
946
947 git_clone_linux_sources
948 git_export_linux_sources
949
950 select_compiler
951
952 ## PREPARE FULL LINUX SOURCE TREE
953 build_linux_kernel
954
955 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
956 extract_distro_headers
957
958 tar_archive_obj
959
960 upload_archive_obj
961
962 ;;
963
964 *)
965 echo "Unknown error? Abort"
966 exit 1
967 ;;
968 esac
969
970 select_compiler
971
972 selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
973 # lttng-modules requires gcc >= 5.1 for aarch64
974 # @see https://github.com/lttng/lttng-modules/commit/be06402dbdbea2f3394e60ec15c5d3356e2be416
975 if { verlt "${selected_cc_version}" "5.1"; } && [ "${cross_arch}" = "arm64" ] ; then
976 echo "Building lltng-modules on aarch64 requires gcc >= 5.1"
977 exit 0
978 fi
979
980 ## BUILD modules
981 # Either we downloaded a pre-build kernel or we built it and uploaded
982 # the archive for future builds.
983
984 cd "$WORKSPACE"
985
986 # Build modules against full kernel sources
987 build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
988
989 # Build modules against kernel headers
990 build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
991
992 # Make sure some modules were actually built
993 tree "${MODULES_OUTPUT_KSRC_DIR}"
994 if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
995 echo "No modules built!"
996 exit 1
997 fi
998
999 tree "${MODULES_OUTPUT_KHDR_DIR}"
1000 if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
1001 echo "No modules built!"
1002 exit 1
1003 fi
1004
1005 # EOF
This page took 0.066145 seconds and 5 git commands to generate.